# coding=UTF-8

import gtk

#
# Sensor for BubbleFishyMon
# Version 0.1 (16/04/2004)
#
# This module contains various functions to transform colours
#
# By Vassili Geronimos (mr_spot@optusnet.com.au)
#
# Based on the BubbleFishyMon dockapp
#

# Find the colour at a particular point in a colour gradient.
def colour_trans(start, end, position):
	s = gtk.gdk.color_parse(start)
	e = gtk.gdk.color_parse(end)
	
	red = (e.red * position) + (s.red * (1 - position))
	green = (e.green * position) + (s.green * (1 - position))
	blue = (e.blue * position) + (s.blue * (1 - position))

	return "#%04x%04x%04x" % (red, green, blue)
