# coding=UTF-8



#
# Sensor for BubbleFishyMon
# Version 0.1 (16/04/2004)
#
# This module contains various functions to transform a bunch of points into a
# form usable by gDesklets.
#
# By Vassili Geronimos (mr_spot@optusnet.com.au)
#
# Based on the BubbleFishyMon dockapp
#


CANVAS_WIDTH=180
CANVAS_HEIGHT=145

def transform(x,y,ox,oy):
	x = ( (x+ox) / (float(CANVAS_WIDTH)  / 2)) - 1
	y = (-(y+oy) / (float(CANVAS_HEIGHT) / 2)) + 1
	return x,y

def transform_poly(list,ox,oy,fill):
	points = ""
	while list:
		x = list.pop(0)
		y = list.pop(0)
		x,y = transform(x,y,ox,oy)
		points = points + "%(x)f %(y)f " % vars()
	return "polygon " + points + str(fill)

def transform_pline(list,ox,oy):
	points = []
	while list:
		x = list.pop(0)
		y = list.pop(0)
		x,y = transform(x,y,ox,oy)
		points.append(x)
		points.append(y)
	pline=""
	for n in range(0, len(points)-2, 2):
		pline = pline + ",line %f %f %f %f" % (points[n],points[n+1],points[n+2],points[n+3])
	return pline
	
def flip_x(poly,w):
	for n in range(0, len(poly), 2):
		poly[n] = (w-1)-poly[n]
	return poly
