from sensor.Sensor import Sensor
from utils.datatypes import *

# By Martin Klaffenboeck <martin.klaffenboeck@gmx.at>

class Image(Sensor):
	def __init__(self, img=""):
		Sensor.__init__(self)
		
		self._set_config_type("uri", TYPE_STRING, img)
		self._set_config_type("scale", TYPE_INT, 100)
		
		self._watch_config(self.config_watcher)
		self._add_timer(500, self.__image_init)
		
	def __image_init(self):
		out = self._new_output()
		out.set("i-uri", self._get_config("uri"))
		s = self._get_config("scale")
		s = float(s) / 100
		out.set("i-scale", s)
		self._send_output(out)
		return 0
	
	def config_watcher(self,key,value):
		self.__image_init()
	
	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name("Image")
		configurator.add_title("Image Settings")
		
		configurator.add_file_selector("Image file:", "uri",
		                       "Sets the file name")
		configurator.add_spin("Scale (%):", "scale",
		                      "Scale the Image in %",
                             0, 800)
		return configurator


def new_sensor(args):
	return apply(Image, args)
