import socket
from string import *
from time import *

class ImondConnection:

	def __init__(self, hostname = "fli4l", port = 5000, pw = ""):
		self._hostname = hostname
		self._port = port
		self._pw = pw
		self.connected = 0

	def connect(self):
		self._s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		try:
			self._s.connect((self._hostname,self._port))
		except socket.gaierror:
			self._s = None
			return
		answer = int(self._send_command("pass"))
		if (answer == 1 or answer == 3):
			answer = self._send_command("pass " + self._pw)  
		if (answer== "ERR"):
			print "ImondConecction.connect(): password error\n"
		self._pppoe = self._send_command("pppoe")
		self.connected = 1

	def disconnect(self):
		if (self._s == None):
			return
		self._send_command("quit")
		self._s.close()

	def get_hostname(self):
		return self._send_command("hostname")

	def get_version(self):
		return split(self._send_command("version"))[1]

	def get_uptime(self):
		retval = ''
		uptime = int(self._send_command("uptime"));
		hours = uptime/3600
		minutes = (uptime-hours*3600)/60
		seconds = (uptime-hours*3600-minutes*60)
		retval += str(hours) + ":"
		if (minutes < 10):
			retval += "0"
		retval += str(minutes)
		return retval

	def get_date(self):
		date = self._send_command("date");
		return date
		#date = date[find(date," ")+1:]
		#return strftime("%c",strptime(date,"%d/%m/%Y %H:%M:%S"))

	def get_cpu(self):
		return self._send_command("cpu")

	def get_rate(self, device = "pppoe"):
		answer = split(self._send_command("rate " + device))
		if (answer[0] == "ERR"):
			return None
		answer[0] = int(answer[0])
		answer[1] = int(answer[1])
		return answer

	def _send_command(self, str):
		if (self._s == None):
			return None
		if (str == "" or str == None):
			return None
		self._s.send(str+"\r\n")
		answer = strip(self._s.recv(1024))
		if (answer != "ERR"):
			answer = replace(answer, "OK ", "") # throw away trailing "OK "
#		print "_send_command(): command='" + str + "' - answer='" + answer +"'"
		return answer
