from sensor.Sensor import Sensor

import ltxmms, time, string, os

# Copyright 2003 Jesse Andrews under GPL (fsf.org)

class XmmsSensor( Sensor ):

	def __init__( self ):
		Sensor.__init__( self )
                self._startindex = 0;
                self._vol = 100;
		self._add_timer( 0, self.__get_data )
		self._add_timer( 0, self.__get_title_data )

	def __get_data( self ):
		try:
			cur = ltxmms.get_playlist_pos()
			time = ltxmms.get_output_time() 
			self.__length = ltxmms.get_playlist_time( cur )
			bitrate = int(ltxmms.get_info()[0])/1000
		        encoding = int(ltxmms.get_info()[1])/1000
			nchannels = int(ltxmms.get_info()[2])
                        fill = float(time) / float(self.__length)
                        vol = max(ltxmms.get_volume()[0], ltxmms.get_volume()[1])

		except:
			self.__length, time, fill, vol, bal = 0, 0, 0, 0, 50
                        bitrate, encoding, nchannels = 0, 0, 0

                if (nchannels == 2):
                        chstring = "STEREO"
                elif (nchannels == 1):
                        chstring = "MONO"
                else:
                        chstring = "NONE"

		output = self._new_output()
		output.set( "length", "Len: %d:%02d" % (self.__length/60000,(self.__length/1000)%60))
		output.set( "fill", int(fill*100) )
                output.set( "volume", int(vol) )
                output.set( "bit", "%dkbps" % bitrate )
                output.set( "enc", "%dKHz" % encoding )
                output.set( "nch", chstring )

		self._add_timer( 1000, self.__get_data )
		self._send_output( output )

	def __get_title_data( self ):
                try:
			cur = ltxmms.get_playlist_pos()
			title = ltxmms.get_playlist_title( cur )
                except:
                        title = "XMMS Not Loaded"

		output = self._new_output()
		output.set( "title", self.__scrolltitle(title))
		self._add_timer( 300, self.__get_title_data )
		self._send_output( output )

        def __scrolltitle(self,title):
                if (title == None):
                    title = "No Song Loaded"

                title = "%s * %s * %s * " % (title, title, title)
                title = string.replace(title,"&","and")
                start = self._startindex
                end = self._startindex + 25
                final = len(title) - 1

                if (final-start < 25):
                    diff = 25 - (final - start)
                    stitle = "%s%s" % (title[start:final],title[0:diff])
                else:
                    stitle = "%s" % title[start:end]

                self._startindex = self._startindex + 1;
                if (self._startindex > final):
                    self._startindex = 0;

                return stitle

	def call_action( self, action, path, args = []):
		
		if (action == "stop"):
                        if (ltxmms.is_playing()):
			    ltxmms.stop()
                        else:
                            os.system("pkill xmms &")

		if (action == "play"):
                        if (os.system('pgrep xmms >& /dev/null') == 0):
                            ltxmms.play()
                        else:
                            os.system("nohup xmms &")

		if (action == "next"):
			ltxmms.playlist_next()

		if (action == "prev"):
			ltxmms.playlist_prev()

		if (action == "pause"):
			ltxmms.pause()
    
                if (action == "cvn"):
                        self._vol = (args[0] * 100) / 33

                if (action == "cv"):
                        ltxmms.set_volume(self._vol) 

                if (action == "cposn"):
                        self._pos = (args[0] * self.__length) / 140

                if (action == "cpos"):
                        ltxmms.jump_to_time(self._pos) 

def new_sensor( args ): return apply( XmmsSensor, args )
