from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

# influenced by rssgrab

class ListSensor(Sensor):
	def __init__(self, *args):
		global _; _ = i18n.Translator("list")

		Sensor.__init__(self)

		for i in range (10):
			self._set_config_type ("item%(i)d" % vars (), TYPE_STRING, "")

		self._set_config_type ("font", TYPE_STRING, "Sans 12")
		self._set_config_type ("listcolor", TYPE_STRING, "black")
		self._set_config_type ("activefont", TYPE_STRING, "Sans 12")
		self._set_config_type ("activecolor", TYPE_STRING, "yellow")

		self._add_timer (500, self.update)
		# update when needed
		self._watch_config (self.update)

	def update(self, key="", value=""):
		output = self._new_output()

		for i in range (10):
			value = self._get_config ("item" + str (i))
			if value == "": value = " "
			output.set("item[%(i)d]" % vars (), value)
			output.set("font[%(i)d]" % vars (), self._get_config ("font"))
			output.set("color[%(i)d]" % vars (), self._get_config ("listcolor"))
        
		self._send_output(output)

		return 0


	def get_configurator (self):
		conf = self._new_configurator ()

		conf.set_name (_("List"))
		conf.add_title (_("Fonts"))
		conf.add_font_selector (_("List font"), "font", _("The font used for inactive list items"))
		conf.add_color_selector (_("List font color"), "listcolor", _("Font color for inactive list items"))
		conf.add_font_selector (_("Active font"), "activefont", _("The font used for active list items"))
		conf.add_color_selector (_("Active font color"), "activecolor", _("Font color for active list items"))
		conf.add_title (_("List items"))
		for i in range (10):
			conf.add_entry (_("Item %(i)d" % vars ()), "item%(i)d" % vars (), _("List item"))
		
		return conf

	def call_action (self, action, path, args = []):
		index = int (path[-1])

		if (action == "done"):
			# move the completed item to the end and empty it
			for i in range (index, 9):
				tmp = self._get_config ("item" + str (i+1))
				self._set_config ("item" + str (i+1), self._get_config ("item" + str (i)))
				self._set_config ("item" + str (i), tmp)

			# empty the last one
			self._set_config ("item9", "")
		if (action == "enter"):
			output = self._new_output ()
			output.set ("font[%(index)d]" % vars(), self._get_config ("activefont"))
			output.set ("color[%(index)d]" % vars(), self._get_config ("activecolor"))
			self._send_output (output)
		if (action == "leave"):
			output = self._new_output ()
			output.set ("font[%(index)d]" % vars(), self._get_config ("font"))
			output.set ("color[%(index)d]" % vars(), self._get_config ("listcolor"))
			self._send_output (output)
	
def new_sensor(args): return ListSensor(*args)
