from sensor.Sensor import Sensor

import os
import commands
import time
from utils.datatypes import *
from utils import i18n
                                                                                      
#
# sensor to use for searching web sites
# this is a generic sensor that relies on
# an outside script or program for the searching
# the results are sent to the output channel 
# names "value"
#
class SearchSensor(Sensor):
   

    def __init__(self):
        global _; _ = i18n.Translator("rss-desklet")
        Sensor.__init__(self)
        # set defaults
        self._set_config_type("search_cmd", TYPE_STRING, "SearchEbay.pl");
        self._set_config_type("search_string", TYPE_STRING, "Radio Tuning Eye");
        self._set_config_type("browser_cmd", TYPE_STRING, "mozilla http://ebay.com&");
        self._set_config_type("search_cmd", TYPE_STRING, "SearchEbay.pl");
        self._set_config_type("search_max_result_count", TYPE_STRING, "10");
        self._set_config_type("search_interval", TYPE_STRING, "60");
        self._add_thread(self.__search_thread)

    def __search_thread(self):
        while (1):
            if (self._is_stopped()):
                break
	    cmdstr = self._get_config("search_cmd") \
			+ " \"" + self._get_config("search_string") + "\" " \
			+ str(self._get_config("search_max_result_count")); 
            fail, result =  commands.getstatusoutput(cmdstr)
	    if (fail): result = ""
            out = self._new_output()
            out.set("value", result)
            self._send_output(out)
            time.sleep(float(self._get_config("search_interval"))/60)
                                                                                      
    def get_configurator(self):
        configurator = self._new_configurator()
        configurator.set_name(_("Search"))
        configurator.add_title(_("Search Settings"))
        configurator.add_entry(_("Search Script",),"search_cmd", _("Path To Search Script")) 
        configurator.add_entry(_("Search Expression",),"search_string", _("Search Expression")) 
        configurator.add_entry(_("Max Results",), "search_max_result_count", _("Max Number of Results")) 
        configurator.add_entry(_("Search Interval",),"search_interval", _("Search Interval In Minuets")) 
        configurator.add_entry(_("Web Browser",),"browser_cmd", _("Command To Launch Web Browser")) 
        return configurator

    #run commands on user's actions
    def call_action(self, action, path, args = []):
        if (action == "run_browser"):
            os.system(self._get_config("browser_cmd") )

def new_sensor(args): return apply(SearchSensor, args)
