from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import commands
import os
import time

from HTMLParser import HTMLParser
from os.path import basename
from re import match, sub, split
import httplib, urllib

class MyHTMLParser(HTMLParser):
        nextdata = "0"
        change = ""
        def handle_starttag (self, tag, attrs):
                if (self.nextdata == "change" and tag == "img"):
                        if (match("up", basename(attrs[3][1]))):
                                self.change = "+"
				self.changecolor = "green"
                        elif (match("down", basename(attrs[3][1]))):
                                self.change = "-"
				self.changecolor = "red"
                        else:
                                self.change = ""
				self.changecolor = "white"
                elif tag == "title":
                        self.nextdata = "name"
                                                                                                                                      
        def handle_data (self, data):
                if (data == "Last Trade:" or data == "Index Value:"):
                        self.nextdata = "current"
                elif (self.nextdata == "current"):
			self.current = data
                        self.nextdata = "0"
                elif (data == "Change:"):
                        self.nextdata = "change"
                elif (self.nextdata == "change" and data != " "):
			self.changev, self.changep = split(" ", data)
                        self.nextdata = "0"
                elif self.nextdata == "name":
                        self.name = sub(r".*Summary for (.*) - Yahoo.*", r"\1", data)
                        self.nextdata = "0"


def get_html(stockid):
	url = "/q?s=" + stockid
	conn = httplib.HTTPConnection("finance.yahoo.com:80")
	conn.request("GET", url)
	response = conn.getresponse()
	data = response.read()
	conn.close()
	return data

class Stock(Sensor):
	

	def __init__(self, interval = "10000"):
		Sensor.__init__(self)
		
		self._set_config_type("update", TYPE_INT, int(interval))
		self._set_config_type("stock_symbol", TYPE_STRING, "")
		self._set_config_type("stock_show_name", TYPE_BOOL, 0)
		self._set_config_type("stock_show_value", TYPE_BOOL, 1)
		self._set_config_type("stock_show_changev", TYPE_BOOL, 0)
		self._set_config_type("stock_show_changep", TYPE_BOOL, 0)
	
		self.__name = ""
		self.__current = ""
		self.__change = ""
		self.__changecolor = "white"
		self.__changev = ""
		self.__changep = ""
	
		self._add_timer(int(interval), self.__on_tick)
		self._add_thread(self.__command_thread, 0.001 * int(interval))

	def get_configurator(self):

		configurator = self._new_configurator()
		configurator.set_name("Stockvalue fetcher")
		configurator.add_title("Settings")
		configurator.add_spin("Update every (ms):", "update",
					"Updates the display(s) every x milliseconds",
					1*1000, 3600*24*1000)
		configurator.add_entry("Symbol", "stock_symbol",
					"Stock symbol")
		configurator.add_checkbox("Show name", "stock_show_name",
					"Shows the full stock name")
		configurator.add_checkbox("Show value", "stock_show_value",
					"Shows the current stock value")
		configurator.add_checkbox("Show change", "stock_show_changev",
					"Shows the stock value change")
		configurator.add_checkbox("Show change (%)", "stock_show_changep",
					"Shows the stock value change (in %)")
		
		return configurator

	def __on_tick(self):

		data = self._new_output()
		if self._get_config("stock_show_name"):
			data.set("name",self.__name + ":")
		else:
			data.set("name", self._get_config("stock_symbol") + ":")
		if self._get_config("stock_show_value"):
			data.set("current",self.__current)
		if (self._get_config("stock_show_changev") and self._get_config("stock_show_changep")):
			data.set("changev",self.__change + str(self.__changev))
			data.set("changep",self.__changep)
		elif self._get_config("stock_show_changev"):
			data.set("changev",self.__change + str(self.__changev))
		elif self._get_config("stock_show_changep"):
			data.set("changep",self.__change + self.__changep)
		data.set("changecolor",self.__changecolor)
		self._send_output(data)

		return 1



	def __command_thread(self, interval):

		while (1):
			if (self._is_stopped()):
				break
		
			try:
				parse = MyHTMLParser()
				feedage = get_html(self._get_config("stock_symbol"))
				parse.feed(feedage)
				self.__name = parse.name
				self.__current = parse.current
				self.__change = parse.change
				self.__changecolor = parse.changecolor
				self.__changev = parse.changev
				self.__changep = parse.changep
			except:
				self.__name = "Error!"
			
			time.sleep(0.001*self._get_config("update"))
				

def new_sensor(args): return apply(Stock, args)
