from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n
import time
import os

class Theme(Sensor):

	def __init__(self, group, part):
		
		global _; _ = i18n.Translator("theme-sensor")
		Sensor.__init__(self)
		home = os.getenv("HOME")
		if os.path.exists(home + "/.gdesklets/Themes/" + group):
			self.__Sensor_Root = home + "/.gdesklets/Themes/"
		else :
			self.__Sensor_Root = "/usr/share/gdesklets/Themes/"
		
		self.__Group = group
		self.__Part = part
		
		try :
			fd = open(self.__Sensor_Root + self.__Group +"/"+ self.__Part +"/themes", "r")
			output = fd.read()
			fd.close()
		except :
			output = ""
		
		output = output.splitlines()
		self.__Themes = []
		for a in output[0].split():
			self.__Themes.append([a,a])
			
		self.__Elements = output[1].split()
		
		self._set_config_type("show", TYPE_BOOL, 1)
		self._set_config_type("theme", TYPE_STRING, self.__Themes[0][0])
		
		self._watch_config(self.config_watcher)
		
		self._add_timer(500, self.__theme_init)

	def config_watcher(self,key,value):
		if key == "show":
			data = self._new_output()
			data.set(key, value)
			self._send_output(data)
		elif key == "theme":
			data = self._new_output()
			dir = self.__Sensor_Root + self.__Group +"/"+ self.__Part +"/"+ value +"/"
			for element in self.__Elements:
				data.set(element, dir + element + ".png" )
			self._send_output(data)

	def __theme_init(self):
		data = self._new_output()
		
		show = self._get_config("show")
		theme = self._get_config("theme")
		
		data.set("show", show)
		
		dir = self.__Sensor_Root + self.__Group +"/"+ self.__Part +"/"+ theme +"/"
		for element in self.__Elements:
			data.set(element, dir + element + ".png" )
		
		self._send_output(data)
		
		return 0

	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name((self.__Part))
		configurator.add_title((self.__Group))
		configurator.add_checkbox(("Show this part"), "show",
					("Shows or hides this part of the display"))
		print self.__Themes
		configurator.add_option(("Theme"), "theme",
					("Possible themes"),self.__Themes)
		return configurator

def new_sensor(args): return apply(Theme, args)
