## XMLQuotes - xmldata.py
#   - Created by: Daniel Alves <daniel.alves@linux-portugal.org>

## 2.4

from xml.dom.minidom import parse
import commands
import random

newdom = '<?xml version="1.0" ?><deskquotes></deskquotes>'

class XMLData:
	def __init__(self, xmlfile = ""):
		self.__changed = 0
		self.__xmlfile = xmlfile

	def get_file(self):
		return self.__xmlfile

	def set_file(self, xmlfile):
		self.__xmlfile = xmlfile
		
	def create_file(self, file, keep_open = 0):
		if ( self.__xmlfile == "" ):
			newfile = open(file, "w")
			newfile.write(newdom)
			self.__xmlfile = file
			if (keep_open == 1):
				self.open_dom()

	def open_dom(self):
		if ( self.__xmlfile != "" ):
			self.__dom = parse(self.__xmlfile)

	def close_dom(self):
		if self.__changed == 1:
			commands.getoutput("rm -Rf " + self.__xmlfile)
			outstring = self.__dom.toprettyxml()
			newfile = open(self.__xmlfile, "w")
			newfile.write(outstring)
		self.__dom.unlink()

	def get_quote(self):
		# get tags
		tag_quote = self.__dom.getElementsByTagName("quote")
		# number of tags
		entries = tag_quote.length
		# get a random quote
		self.__quote_id = random.randint(0, entries - 1)
		self.__quote = tag_quote.item(self.__quote_id).childNodes.item(0).nodeValue
		self.__quote_author = tag_quote.item(self.__quote_id).getAttribute("author")
		return self.__quote

	def get_quote_by_id(self, quote_id):
		# get tags
		tag_quote = self.__dom.getElementsByTagName("quote")
		# get tag and return it
		self.__quote_id = quote_id
		self.__quote = tag_quote.item(quote_id).childNodes.item(0).nodeValue
		self.__quote_author = tag_quote.item(quote_id).getAttribute("author")
		return self.__quote

	def get_all_quotes(self, callback):
		tag_quote = self.__dom.getElementsByTagName("quote")
		i = 0
		for node in tag_quote:
			callback( i, node.childNodes.item(0).nodeValue, node.getAttribute("author") )
			i += 1

	def get_author(self):
		return self.__quote_author

	def add_quote(self, quote, author=""):
		self.__changed = 1
		# get document tag
		top = self.__dom.documentElement
		# create new tag
		newquote = self.__dom.createElement("quote")
		newquote_value = self.__dom.createTextNode(quote)
		newquote.appendChild(newquote_value)
		# new tag's parameter
		newparam = self.__dom.createAttribute("author")
		newquote.setAttributeNode(newparam)
		newquote.setAttribute("author", author)
		# add the new tag to the document
		top.appendChild(newquote)

	def set_quote(self, quote_id, quote, author=""):
		self.__changed = 1
		# get tags
		tag_quote = self.__dom.getElementsByTagName("quote")
		# change values
		tag_quote.item(int(quote_id)).childNodes.item(0).nodeValue = quote
		tag_quote.item(int(quote_id)).setAttribute("author", author)

	def remove_quote(self, quote_id):
		self.__changed = 1
		top = self.__dom.documentElement
		node = self.__dom.getElementsByTagName("quote").item(quote_id)
		top.removeChild(node)
