from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import os
import string

#=====================================================================
# A Disk Mounter desklet
#=====================================================================
class DiskMount(Sensor):

    # Setup the Sensor
    def __init__(self, *args):

        global _; _ = i18n.Translator("diskmount-desklet")
        Sensor.__init__(self)

        #default config 
        self._set_config_type("path", TYPE_STRING, "/media/cdrom")
        self._set_config_type("id", TYPE_STRING, "cdrom")
        self._set_config_type("fontcolor", TYPE_STRING, "#000000")
        self._set_config_type("font", TYPE_STRING, "Sans 12")
        self._set_config_type("update", TYPE_INT, 10)

        # start checking
        self._add_timer(1000, self.__check_mount_status)

    
    # is the drive mounted or not?
    def __check_mount_status(self):

        output = self._new_output()
        
        command="mount | grep " + self._get_config("path") + " >& /dev/null"
        status = os.system(command)
 
        # check if it's unmounted...        
        if (status == 0):
            output.set("mounted" % vars(), "true")
            output.set("unmounted" % vars(), "false")

            sizes = os.popen("df -h " +  self._get_config("path") + "| tail -1", 'r').readline()

            used = "U: " + string.split(sizes)[2]
            free = "F: " + string.split(sizes)[3]

            output.set("used" % vars(), used)
            output.set("free" % vars(), free)
        else:
            output.set("mounted" % vars(), "false")
            output.set("unmounted" % vars(), "true")
            output.set("used" % vars(), "U: unknown")
            output.set("free" % vars(), "F: unknown")
           

        output.set("font", self._get_config("font"))
        output.set("color", self._get_config("fontcolor"))
        output.set("id" %vars(), self._get_config("id"))
        output.set("x" %vars(), 30-((len(self._get_config("id"))*7.5)/2))
        self._send_output(output)

        # repeat in a while
        myupdate = int(self._get_config("update")) * 1000
        self._add_timer(myupdate, self.__check_mount_status)
 
    # override this ethod to enable user interaction
    def call_action(self, action, path, args = []):

        if (action == "mount"):
            print "Mounting Drive"
            command = "mount " + self._get_config("path")
            print command
            status = os.system(command)

        elif (action == "unmount"):
            print "Unmounting Drive"
            command = "umount " + self._get_config("path")
            print command
            status = os.system(command)
            
    # Add extra config fields
    def get_configurator(self):
 
        conf1 = self._new_configurator()
        conf1.set_name(_("DiskMount Settings"))
        conf1.add_title(_("Desklet Font"))
        conf1.add_font_selector(_("Font"),"font", _("Font used in the title"))
        conf1.add_title(_("Color of Desklet Font"))
        conf1.add_color_selector(_("Color"),"fontcolor", _("Color used in the title"))
        conf1.add_title(_("Mount Point"))
        conf1.add_entry(_("Path",), "path", _("The point where the device gets mounted"))
        conf1.add_title(_("Name of Device"))
        conf1.add_entry(_("Title",), "id", _("The name that gets displayed for the device"))
        conf1.add_title(_("Interval between updates (seconds)"))
        conf1.add_spin(_("Interval",), "update", _("The interval between updates (seconds)"),1,300) 

        return conf1

# Advertise the sensor
def new_sensor(args): return apply(DiskMount, args)

